Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeService.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeService.java	(revision 43920)
@@ -28,6 +28,7 @@
 import java.util.List;
 
 import javax.swing.JOptionPane;
+import org.apache.commons.io.FilenameUtils;
 
 import org.cresques.cts.ICoordTrans;
 import org.cresques.cts.IProjection;
@@ -35,7 +36,6 @@
 import org.gvsig.exportto.ExporttoServiceException;
 import org.gvsig.exportto.ExporttoServiceFinishAction;
 import org.gvsig.exportto.impl.AttributeNamesTranslator;
-import org.gvsig.exportto.swing.prov.file.panel.SelectFileOptionPanel;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
 import org.gvsig.fmap.dal.DataStoreParameters;
@@ -69,149 +69,122 @@
 import org.gvsig.fmap.geom.primitive.Surface;
 import org.gvsig.fmap.geom.type.GeometryType;
 import org.gvsig.i18n.Messages;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.CoercionException;
+import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
 import org.gvsig.tools.dispose.DisposableIterator;
 import org.gvsig.tools.dispose.DisposeUtils;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.threadsafedialogs.ThreadSafeDialogsManager;
 import org.gvsig.tools.task.AbstractMonitorableTask;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
-
 /**
  * @author gvSIG Team
  * @version $Id$
  *
  */
 public class ExporttoShapeService extends AbstractMonitorableTask implements
-    ExporttoService {
+        ExporttoService {
 
-    private static Logger logger = LoggerFactory.getLogger(ExporttoShapeService.class);
+    private static final Logger logger = LoggerFactory.getLogger(ExporttoShapeService.class);
 
     public static final int MAX_FIELD_NAME_LENGTH = 10;
 
-    private File theShapeFile;
-    private IProjection projection;
-    private FeatureStore featureStore;
-    private AttributeNamesTranslator nameTranslator;
+    private final AttributeNamesTranslator nameTranslator;
 
-    private int geometryType = -1;
     private NewFeatureStoreParameters newFeatureStoreParameters;
     private FilesystemServerExplorer filesystemServerExplorer;
-    private SelectFileOptionPanel filePanel = null;
-    private String encoding = null;
 
-    private static GeometryManager geoManager = GeometryLocator.getGeometryManager();
-
     private ExporttoServiceFinishAction exporttoServiceFinishAction;
+    private final ExportShapeOptions options;
 
-    public ExporttoShapeService(
-    		SelectFileOptionPanel fPanel,
-    		FeatureStore featureStore,
-    		IProjection projection) {
+    public ExporttoShapeService(ExportShapeOptions options) {
 
-    	this(fPanel, featureStore, projection, null);
-    }
-    
-    public ExporttoShapeService(
-    		SelectFileOptionPanel fPanel,
-    		FeatureStore featureStore,
-    		IProjection projection,
-    		String encoding) {
-
         super("Export to shape");
-        this.featureStore = featureStore;
-        this.filePanel = fPanel;
-        this.theShapeFile = fPanel.getSelectedFile();
-        this.projection = projection;
-        this.encoding = encoding;
-
-        try {
-            this.nameTranslator = new AttributeNamesTranslator(
-                featureStore.getDefaultFeatureType(), 
+        this.options = options;
+        this.nameTranslator = new AttributeNamesTranslator(
+                this.options.getSourceFeatureType(),
                 MAX_FIELD_NAME_LENGTH
-            );
-		} catch (DataException e) {
-			logger.error("While getting def feat type.", e);
-		}
+        );
     }
 
-	public void export(FeatureSet featureSet) throws ExporttoServiceException {
+    @Override
+    public void export(FeatureSet featureSet) throws ExporttoServiceException {
 
         ExporttoServiceException throw_exp = null;
-        File item_shp = null;
-        String pathFile = theShapeFile.getAbsolutePath();
-        String withoutShp = pathFile.replaceAll("\\.shp", "");
+        File item_shp;
+        
+        String layer_name = FilenameUtils.getBaseName(this.options.getFile().getName());
+        String pathName = FilenameUtils.removeExtension(this.options.getFile().getAbsolutePath());
 
-        File single_file = new File(withoutShp + ".shp");
-
-        String layer_name = single_file.getName();
-        int lastp = layer_name.lastIndexOf(".shp");
-        if (lastp > -1) {
-            layer_name = layer_name.substring(0, lastp);
-        }
-
-        initializeParams(featureSet, single_file);
-
+        int geometryType = options.getGeometryTypeAsInt();
+        
         if (geometryType == Geometry.TYPES.GEOMETRY) {
             // SURFACE
-            String fileName = withoutShp + "_surface" + ".shp";
-            item_shp = new File(fileName);
+            String fullPathName = pathName + "_surface" + ".shp";
+            item_shp = new File(fullPathName);
             initializeParams(featureSet, item_shp);
             newFeatureStoreParameters.setDynValue("shpfile", item_shp);
             taskStatus.setTitle("Exporting surfaces");
 
-            try {
-                export(filesystemServerExplorer, newFeatureStoreParameters,
-                    featureSet, Geometry.TYPES.SURFACE, true);
-            } catch (ExporttoServiceException ee) {
-                throw_exp = ee;
-            }
-            finishAction(layer_name + " (surface)", item_shp, projection);
+            export(
+                    filesystemServerExplorer, 
+                    newFeatureStoreParameters,
+                    featureSet, 
+                    Geometry.TYPES.SURFACE, 
+                    true
+            );
+            finishAction(layer_name + " (surface)", item_shp, options.getTargetProjection());
 
             // CURVE
-            fileName = withoutShp + "_curve" + ".shp";
-            item_shp = new File(fileName);
+            fullPathName = pathName + "_curve" + ".shp";
+            item_shp = new File(fullPathName);
             initializeParams(featureSet, item_shp);
             newFeatureStoreParameters.setDynValue("shpfile", item_shp);
             taskStatus.setTitle("Exporting curves");
 
-            try {
-                export(filesystemServerExplorer, newFeatureStoreParameters,
-                    featureSet, Geometry.TYPES.CURVE, true);
-            } catch (ExporttoServiceException ee) {
-                throw_exp = ee;
-            }
+            export(
+                    filesystemServerExplorer, 
+                    newFeatureStoreParameters,
+                    featureSet, 
+                    Geometry.TYPES.CURVE, 
+                    true
+            );
 
-            finishAction(layer_name + " (curve)", item_shp, projection);
+            finishAction(layer_name + " (curve)", item_shp, options.getTargetProjection());
 
             // POINT
-            fileName = withoutShp + "_point" + ".shp";
-            item_shp = new File(fileName);
+            fullPathName = pathName + "_point" + ".shp";
+            item_shp = new File(fullPathName);
             initializeParams(featureSet, item_shp);
 
             newFeatureStoreParameters.setDynValue("shpfile", item_shp);
             taskStatus.setTitle("Exporting points");
 
-            try {
-                export(filesystemServerExplorer, newFeatureStoreParameters,
-                    featureSet, Geometry.TYPES.POINT, true);
-            } catch (ExporttoServiceException ee) {
-                throw_exp = ee;
-            }
+            export(
+                    filesystemServerExplorer, 
+                    newFeatureStoreParameters,
+                    featureSet, 
+                    Geometry.TYPES.POINT, 
+                    true
+            );
 
-            finishAction(layer_name + " (point)", item_shp, projection);
+            finishAction(layer_name + " (point)", item_shp, options.getTargetProjection());
 
-
         } else {
-
-            // params already initialized
+            File single_file = new File(pathName + ".shp");
+            initializeParams(featureSet, single_file);
             newFeatureStoreParameters.setDynValue("shpfile", single_file);
-            try {
-                export(filesystemServerExplorer, newFeatureStoreParameters,
-                    featureSet, geometryType, false);
-            } catch (ExporttoServiceException ee) {
-                throw_exp = ee;
-            }
-            finishAction(layer_name, single_file, projection);
+            export(
+                    filesystemServerExplorer, 
+                    newFeatureStoreParameters,
+                    featureSet, 
+                    geometryType, 
+                    false
+            );
+            finishAction(layer_name, single_file, options.getTargetProjection());
         }
         this.taskStatus.terminate();
         this.taskStatus.remove();
@@ -219,74 +192,75 @@
         if (throw_exp != null) {
             throw throw_exp;
         } else {
-        	if ( this.nameTranslator.hasTranslations() ) {
-        		showNewNamesDialog(this.nameTranslator);
-        	}
+            if (this.nameTranslator.hasTranslations()) {
+                showNewNamesDialog(this.nameTranslator);
+            }
         }
     }
 
     private void showNewNamesDialog(AttributeNamesTranslator nameTranslator) {
-        if( nameTranslator.hasTranslations() ) {
+        if (nameTranslator.hasTranslations()) {
             String msg = Messages.getText("_Some_field_names_too_long_automatically_changed");
             msg = msg + ":\n";
-            for( String source_name : nameTranslator ) {
+            for (String source_name : nameTranslator) {
                 String target_name = nameTranslator.getTargetName(source_name);
                 msg = msg + "\n" + source_name + " > " + target_name;
             }
-            JOptionPane.showMessageDialog(
-                this.filePanel,
-                msg,
-                Messages.getText("export_progress"),
-                JOptionPane.WARNING_MESSAGE);
+            ThreadSafeDialogsManager dialogs = ToolsSwingLocator.getThreadSafeDialogsManager();
+            dialogs.messageDialog(
+                    msg,
+                    null,
+                    Messages.getText("export_progress"),
+                    JOptionPane.WARNING_MESSAGE,
+                    "FieldNameTooLongInShape"
+            );
         }
     }
 
-	private void initializeParams(
-        FeatureSet featureSet, File out_shp_file)
-        throws ExporttoServiceException {
+    private void initializeParams(
+            FeatureSet featureSet, File out_shp_file)
+            throws ExporttoServiceException {
 
         DataManager dataManager = DALLocator.getDataManager();
 
         FilesystemServerExplorerParameters explorerParams;
         try {
-            explorerParams =
-                (FilesystemServerExplorerParameters) dataManager
-                    .createServerExplorerParameters(FilesystemServerExplorer.NAME);
-        } catch (InitializeException e) {
+            explorerParams
+                    = (FilesystemServerExplorerParameters) dataManager
+                            .createServerExplorerParameters(FilesystemServerExplorer.NAME);
+        } catch (InitializeException | ProviderNotRegisteredException e) {
             throw new ExporttoServiceException(e);
-        } catch (ProviderNotRegisteredException e) {
-            throw new ExporttoServiceException(e);
         }
         explorerParams.setRoot(out_shp_file.getParent());
 
         try {
-            filesystemServerExplorer =
-                (FilesystemServerExplorer) dataManager.openServerExplorer(
-                    "FilesystemExplorer", explorerParams);
+            filesystemServerExplorer
+                    = (FilesystemServerExplorer) dataManager.openServerExplorer(
+                            "FilesystemExplorer", explorerParams);
         } catch (Exception e) {
             throw new ExporttoServiceException(e);
         }
 
         try {
-            newFeatureStoreParameters =
-                (NewFeatureStoreParameters) filesystemServerExplorer
-                    .getAddParameters(out_shp_file);
+            newFeatureStoreParameters
+                    = (NewFeatureStoreParameters) filesystemServerExplorer
+                            .getAddParameters(out_shp_file);
         } catch (DataException e) {
             throw new ExporttoServiceException(e);
         }
 
-        newFeatureStoreParameters.setDynValue("CRS", projection);
-        newFeatureStoreParameters.setDynValue("encoding", encoding);
+        newFeatureStoreParameters.setDynValue("CRS", options.getTargetProjection());
+        newFeatureStoreParameters.setDynValue("encoding", options.getEncoding());
 
-        geometryType =
-            featureSet.getDefaultFeatureType().getDefaultGeometryAttribute()
-                .getGeomType().getType();
-
     }
 
-    private void export(FilesystemServerExplorer explorer,
-        NewFeatureStoreParameters params, FeatureSet featureSet,
-        int geometryType, boolean checkType) throws ExporttoServiceException {
+    private void export(
+            FilesystemServerExplorer explorer,
+            NewFeatureStoreParameters params, 
+            FeatureSet featureSet,
+            int geometryType, 
+            boolean checkType
+        ) throws ExporttoServiceException {
 
         String providerName = params.getDataStoreName();
         String explorerName = explorer.getProviderName();
@@ -294,45 +268,46 @@
 
         DisposableIterator it = null;
         try {
-            EditableFeatureType type =
-                featureStore.getDefaultFeatureType().getCopy().getEditable();
+            EditableFeatureType type = this.options.getSourceFeatureType().getCopy().getEditable();
 
-            FeatureAttributeDescriptor fad =
-                (FeatureAttributeDescriptor) type.get(type
-                    .getDefaultGeometryAttributeName());
-
-            type.remove(fad.getName());
-            EditableFeatureAttributeDescriptor efad =
-                type.add(fad.getName(), fad.getType(), fad.getSize());
-            efad.setDefaultValue(fad.getDefaultValue());
-
-            int gsubtype = fad.getGeomType().getSubType();
+            String geomFieldName = this.options.getGeometryFieldName();
+            
+            FeatureAttributeDescriptor geomFieldDescSource = (FeatureAttributeDescriptor) type.getDefaultGeometryAttribute();
+            if( geomFieldDescSource!=null ) { 
+                type.remove(geomFieldDescSource.getName());
+            }
+            EditableFeatureAttributeDescriptor geomFieldDescTarget = type.add(
+                    "GEOMETRY",
+                    this.options.getGeometryTypeAsInt()
+            );
+            geomFieldDescTarget.setDefaultValue(null);
+            int gsubtype = this.options.getGeometrySubtype();
             // El shp solo soporta los subtipos 2D y 3D
-            switch( gsubtype ) {
-            case Geometry.SUBTYPES.GEOM2D:
-                break;
-            case Geometry.SUBTYPES.GEOM3D:
-                break;
-            default:
-                // Forzaremos las geometrias a 3D
-                gsubtype = Geometry.SUBTYPES.GEOM3D;
-                break;
+            switch (gsubtype) {
+                case Geometry.SUBTYPES.GEOM2D:
+                    break;
+                case Geometry.SUBTYPES.GEOM3D:
+                    break;
+                default:
+                    // Forzaremos las geometrias a 3D
+                    gsubtype = Geometry.SUBTYPES.GEOM3D;
+                    break;
             }
             GeometryType gty = null;
             try {
+                GeometryManager geoManager = GeometryLocator.getGeometryManager();
                 gty = geoManager.getGeometryType(geometryType, gsubtype);
             } catch (Exception e) {
                 throw new ExporttoServiceException(e);
             }
 
-            efad.setGeometryType(gty);
+            geomFieldDescTarget.setGeometryType(gty);
 
-            efad.setName(this.nameTranslator.getTargetName(fad.getName()));
-            efad.setPrecision(fad.getPrecision());
+            geomFieldDescTarget.setName(this.nameTranslator.getTargetName(geomFieldDescSource.getName()));
+            geomFieldDescTarget.setPrecision(geomFieldDescSource.getPrecision());
 
+            type.setDefaultGeometryAttributeName(geomFieldDescTarget.getName());
 
-            type.setDefaultGeometryAttributeName(efad.getName());
-
             // ==========================
             fixNames(type);
             // ==========================
@@ -344,9 +319,8 @@
             DataManager manager = DALLocator.getDataManager();
 
             manager.newStore(explorerName, providerName, params, true);
-            FeatureStore target =
-                (FeatureStore) manager.openStore(providerName, params);
-
+            
+            FeatureStore target = (FeatureStore) manager.openStore(providerName, params);
             FeatureType targetType = target.getDefaultFeatureType();
 
             taskStatus.setRangeOfValues(0, featureSet.getSize());
@@ -357,84 +331,111 @@
 
             // ================================================
             // Reprojection stuff
-            Geometry reproj_geom = null;
-            EditableFeature edit_feat = null;
-            IProjection sourceProjection =
-                featureStore.getDefaultFeatureType().getDefaultGeometryAttribute().getSRS();
+            Geometry reproj_geom;
+            EditableFeature edit_feat;
+            IProjection sourceProjection
+                    = options.getSourceFeatureType().getDefaultGeometryAttribute().getSRS();
 
             ICoordTrans coord_trans = null;
             // this comparison is perhaps too preventive
             // we could  have two instances of same projection
             // so we would do more computations than needed
-            if (sourceProjection != null && sourceProjection != this.projection) {
-                coord_trans = sourceProjection.getCT(this.projection);
+            if (sourceProjection != null && sourceProjection != this.options.getTargetProjection()) {
+                coord_trans = sourceProjection.getCT(this.options.getTargetProjection());
             }
             // ================================================
 
-            List<Geometry> extracted = null;
-            Geometry gitem = null;
-
+            List<Geometry> extracted;
+            Geometry gitem ;
+            Coercion toGeometry = ToolsLocator.getDataTypesManager()
+                    .get(DataTypes.GEOMETRY).getCoercion();
+            
             while (it.hasNext()) {
 
                 Feature feature = (Feature) it.next();
-                gitem = feature.getDefaultGeometry();
-
-                if (checkType) {
-                    extracted = getGeometriesFrom(gitem, geometryType);
-                    if (extracted.size() == 0) {
-                        // found no geometries of correct type
-                        continue;
-                    } else {
-                        if (geometryType != Geometry.TYPES.POINT) {
-                            // If not points, merge geometries
-                            // (curves or surfaces)
-                            try {
-                                gitem = union(extracted);
-                                extracted = new ArrayList<Geometry>();
-                                extracted.add(gitem);
-                            } catch (Exception ex) {
-                                there_was_error = true;
-                                logger.info("Error in union.", ex);
+                if( geomFieldName==null ) {
+                    edit_feat = target.createNewFeature(true);
+                    //
+                    // Accumulate error in boolean.
+                    // This also fixes field names (using origNameToDbfName)
+                    // 
+                    there_was_error = there_was_error |
+                        setNonNulls(
+                                options.getSourceFeatureType(),
+                                targetType, 
+                                feature, 
+                                edit_feat
+                        );
+                    edit_feat.setDefaultGeometry(null);                    
+                    target.insert(edit_feat);
+                } else {
+                    Object x = feature.getGeometry(geomFieldName);
+                    try {
+                        gitem = (Geometry) toGeometry.coerce(x);
+                    } catch (CoercionException ex) {
+                        gitem = null;
+                    }
+                    
+                    if (checkType) {
+                        extracted = getGeometriesFrom(gitem, geometryType);
+                        if (extracted.isEmpty()) {
+                            // found no geometries of correct type
+                            continue;
+                        } else {
+                            if (geometryType != Geometry.TYPES.POINT) {
+                                // If not points, merge geometries
+                                // (curves or surfaces)
+                                try {
+                                    gitem = union(extracted);
+                                    extracted = new ArrayList<>();
+                                    extracted.add(gitem);
+                                } catch (Exception ex) {
+                                    there_was_error = true;
+                                    logger.info("Error in union.", ex);
+                                }
+                            } else {
+                                // only in the case of points, we can have several
+                                // geometries if source is multipoint
                             }
-                        } else {
-                            // only in the case of points, we can have several
-                            // geometries if source is multipoint
                         }
+                    } else {
+                        extracted = new ArrayList<>();
+                        extracted.add(gitem);
                     }
-                } else {
-                    extracted = new ArrayList<Geometry>();
-                    extracted.add(gitem);
-                }
 
-                for (int i=0; i<extracted.size(); i++) {
-                    gitem = extracted.get(i);
+                    for (int i = 0; i < extracted.size(); i++) {
+                        gitem = extracted.get(i);
 
-                    if( gsubtype==Geometry.SUBTYPES.GEOM2D ) {
-                        gitem = force2D(gitem, geometryType);
-                    } else {
-                        gitem = force3D(gitem, geometryType);
+                        if (gsubtype == Geometry.SUBTYPES.GEOM2D) {
+                            gitem = force2D(gitem, geometryType);
+                        } else {
+                            gitem = force3D(gitem, geometryType);
+                        }
+                        edit_feat = target.createNewFeature(true);
+                        //
+                        // Accumulate error in boolean.
+                        // This also fixes field names (using origNameToDbfName)
+                        // 
+                        there_was_error = there_was_error |
+                            setNonNulls(
+                                    options.getSourceFeatureType(),
+                                    targetType, 
+                                    feature, 
+                                    edit_feat
+                            );
+                        edit_feat.setDefaultGeometry(gitem);
+                        // ================================================
+                        // Reprojection stuff
+                        if (coord_trans != null && gitem != null) {
+                            reproj_geom = edit_feat.getDefaultGeometry();
+                            reproj_geom = reproj_geom.cloneGeometry();
+                            reproj_geom.reProject(coord_trans);
+                            edit_feat.setDefaultGeometry(reproj_geom);
+                        }
+                        // ================================================
+                        target.insert(edit_feat);
                     }
-                    edit_feat = target.createNewFeature(true);
-                    there_was_error = there_was_error |
-                    		/*
-                    		 * Accumulate error in boolean.
-                    		 * This also fixes field names (using origNameToDbfName)
-                    		 */
-                    		setNonNulls(featureStore.getDefaultFeatureType(),
-                    				targetType, feature, edit_feat);
-                    edit_feat.setDefaultGeometry(gitem);
-                    // ================================================
-                    // Reprojection stuff
-                    if (coord_trans != null && gitem != null ) {
-                        reproj_geom = edit_feat.getDefaultGeometry();
-                        reproj_geom = reproj_geom.cloneGeometry();
-                        reproj_geom.reProject(coord_trans);
-                        edit_feat.setDefaultGeometry(reproj_geom);
-                    }
-                    // ================================================
-                    target.insert(edit_feat);
                 }
-
                 featureCount++;
                 this.taskStatus.setCurValue(featureCount);
 
@@ -452,54 +453,54 @@
 
         if (there_was_error) {
             Exception cause = new Exception(
-                "_Issues_with_attributes_or_geometries");
+                    "_Issues_with_attributes_or_geometries");
             throw new ExporttoServiceException(cause);
         }
     }
 
-
     private void fixNames(EditableFeatureType eft) {
 
-    	FeatureAttributeDescriptor[] atts = eft.getAttributeDescriptors();
-    	EditableFeatureAttributeDescriptor efad = null;
-    	for (int i=0; i<atts.length; i++) {
-    		String new_name = this.nameTranslator.getTargetName(atts[i].getName());
-    		if (new_name != null) {
-    			eft.remove(atts[i].getName());
-    			efad = eft.add(new_name, atts[i].getType(), atts[i].getSize());
-    			efad.setPrecision(atts[i].getPrecision());
-    			if(atts[i].getDataType().getType() == DataTypes.GEOMETRY){
-    				efad.setGeometryType(atts[i].getGeomType());
-    			}
-    		}
-    	}
-	}
+        FeatureAttributeDescriptor[] atts = eft.getAttributeDescriptors();
+        EditableFeatureAttributeDescriptor efad;
+        for (int i = 0; i < atts.length; i++) {
+            String new_name = this.nameTranslator.getTargetName(atts[i].getName());
+            if (new_name != null) {
+                eft.remove(atts[i].getName());
+                efad = eft.add(new_name, atts[i].getType(), atts[i].getSize());
+                efad.setPrecision(atts[i].getPrecision());
+                if (atts[i].getDataType().getType() == DataTypes.GEOMETRY) {
+                    efad.setGeometryType(atts[i].getGeomType());
+                }
+            }
+        }
+    }
 
-	/**
+    /**
      * @param gitem
      * @param geometryType2
      * @return
      */
     private Geometry force2D(Geometry ge, int gt) throws CreateGeometryException {
-        if( ge == null ) {
+        if (ge == null) {
             return null;
         }
         if (ge.getGeometryType().getSubType() == Geometry.SUBTYPES.GEOM2D) {
             return ge;
         } else {
+            GeometryManager geoManager = GeometryLocator.getGeometryManager();
             switch (gt) {
-            case Geometry.TYPES.POINT:
-                Point p = (Point) ge;
-                Point point = geoManager.createPoint(
-                    p.getX(), p.getY(),
-                    Geometry.SUBTYPES.GEOM2D);
-                return point;
-            case Geometry.TYPES.CURVE:
-                return geoManager.createCurve(ge.getGeneralPath(), Geometry.SUBTYPES.GEOM2D);
-            case Geometry.TYPES.SURFACE:
-                return geoManager.createSurface(ge.getGeneralPath(), Geometry.SUBTYPES.GEOM2D);
-            default:
-                return ge;
+                case Geometry.TYPES.POINT:
+                    Point p = (Point) ge;
+                    Point point = geoManager.createPoint(
+                            p.getX(), p.getY(),
+                            Geometry.SUBTYPES.GEOM2D);
+                    return point;
+                case Geometry.TYPES.CURVE:
+                    return geoManager.createCurve(ge.getGeneralPath(), Geometry.SUBTYPES.GEOM2D);
+                case Geometry.TYPES.SURFACE:
+                    return geoManager.createSurface(ge.getGeneralPath(), Geometry.SUBTYPES.GEOM2D);
+                default:
+                    return ge;
             }
         }
     }
@@ -510,19 +511,20 @@
      * @return
      */
     private Geometry force3D(Geometry ge, int gt) throws CreateGeometryException {
-        if( ge == null ) {
+        if (ge == null) {
             return null;
         }
         // Los try catch que hay abajo, son para asegurarse de que la geometría original
         // tiene las 3 dimensiones necesarias. A veces nos llegan geometrías que aunque son de subtipo GEOM3D
         // los puntos del generalPath que contienen no son 3D y no tienen la coordenada Z
-            Point point;
-            switch (gt) {
+        GeometryManager geoManager = GeometryLocator.getGeometryManager();
+        Point point;
+        switch (gt) {
             case Geometry.TYPES.POINT:
                 Point p = (Point) ge;
                 point = geoManager.createPoint(
-                    p.getX(), p.getY(),
-                    Geometry.SUBTYPES.GEOM3D);
+                        p.getX(), p.getY(),
+                        Geometry.SUBTYPES.GEOM3D);
                 try {
                     point.setCoordinateAt(2, p.getCoordinateAt(2));
                 } catch (Exception e) {
@@ -532,8 +534,8 @@
             case Geometry.TYPES.CURVE:
             case Geometry.TYPES.LINE:
                 Line line = geoManager.createLine(Geometry.SUBTYPES.GEOM3D);
-                for (int i = 0; i < ((OrientablePrimitive)ge).getNumVertices(); i++) {
-                    Point vertex = ((OrientablePrimitive)ge).getVertex(i);
+                for (int i = 0; i < ((OrientablePrimitive) ge).getNumVertices(); i++) {
+                    Point vertex = ((OrientablePrimitive) ge).getVertex(i);
                     point = geoManager.createPoint(vertex.getX(), vertex.getY(), Geometry.SUBTYPES.GEOM3D);
                     try {
                         point.setCoordinateAt(2, vertex.getCoordinateAt(2));
